## PROJET: RAFAEL REIS

import pygame, pygame.gfxdraw, math, random as rdm

W, H = 500 , 700

screen = pygame.display.set_mode((W, H))

pygame.init()

pygame.display.set_caption("Color switch")

clock = pygame.time.Clock()

pi=math.pi

 

obstacles = []

obstacles2 = []

obstacles3 = []

etoiles = []

ccs = []

score=0
highscore=0

MENU, GAMEPLAY,GAMEOVER = range(3)

gamestate = MENU

 

ecriture = pygame.font.Font(pygame.font.get_default_font(), 35)

grosse_ecriture = pygame.font.Font(pygame.font.get_default_font(), 80)

 

# Quelques couleurs...

BLACK = (39, 39, 39)

WHITE = (255, 255, 255)

GREY = (200, 200, 200)

RED = (255, 0, 0)

GREEN=(0, 255, 0)

BLUE=(0, 0, 255)

VIOLET = (144, 13, 255)

TURQUOISE =  (50, 219, 240)

YELLOW = (250, 225, 0)

PINK = (255, 1, 129)

 

def random_color():

    rand = rdm.randint(0,3)

    if(rand == 0):

        return VIOLET

    elif(rand == 1):

        return PINK

    elif(rand == 2):

        return TURQUOISE

    elif(rand == 3):

        return YELLOW

 

class Pov:

    def __init__(self):

        self.y = 0
pov = Pov()
 

 

class Obstacle:

    def __init__(self, surface, x, y, vitesse = 1, diametre = 270, thickness = 30, angle = 0):

        self.y = y

        self.x= x

        self.diametre = diametre

        self.thickness = thickness

        self.angle = angle

        self.surface = surface

        self.vitesse = vitesse

    def update(self):

        y = self.y-float(self.diametre/2)-pov.y

        if(y >= H):

            obstacles.remove(self)

            return

        self.angle+=self.vitesse

        if(self.angle > 360):

            self.angle-=360

    def draw(self):

        
        y = self.y-float(self.diametre/2)-pov.y
        x = self.x-float(self.diametre/2)

        pygame.draw.arc(self.surface, VIOLET , (x, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), self.thickness)

        pygame.draw.arc(self.surface, YELLOW , (x, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(270+self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK , (x, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), self.thickness)

       

        pygame.draw.arc(self.surface, VIOLET , (x+1, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), self.thickness)

        pygame.draw.arc(self.surface, YELLOW , (x+1, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x+1, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(270+self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK , (x+1, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), self.thickness)




class Obstacle2:

    def __init__(self, surface, x, y, vitesse = 1, diametre = 250, thickness = 30, angle = 0):

        self.y = y

        self.x= x

        self.diametre = diametre

        self.angle = angle

        self.surface = surface

        self.thickness = thickness

        self.vitesse = vitesse

    def update(self):

        y = self.y-float(self.diametre/2)-pov.y

        if(y >= H):

            obstacles2.remove(self)

            return

        self.angle+=self.vitesse

        if(self.angle > 360):

            self.angle-=360

    def draw(self):

        
        y = self.y-float(self.diametre/2)-pov.y
        x = 0
        pygame.draw.arc(self.surface, VIOLET , (x, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), self.thickness)

        pygame.draw.arc(self.surface, YELLOW , (x, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(self.diametre+self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK , (x, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), self.thickness)

       

        pygame.draw.arc(self.surface, VIOLET , (x+1, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), self.thickness)

        pygame.draw.arc(self.surface, YELLOW , (x+1, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x+1, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(270+self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK , (x+1, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), self.thickness)

        x2 = self.diametre


        pygame.draw.arc(self.surface, YELLOW , (x2, y, self.diametre, self.diametre), math.radians(0-self.angle) ,math.radians(90-self.angle), self.thickness)

        pygame.draw.arc(self.surface, VIOLET , (x2, y, self.diametre, self.diametre), math.radians(90-self.angle) , math.radians(180-self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK , (x2, y, self.diametre, self.diametre), math.radians(180-self.angle) ,math.radians(self.diametre-self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x2, y, self.diametre, self.diametre), math.radians(270-self.angle) ,math.radians(360-self.angle), self.thickness)

       

        pygame.draw.arc(self.surface, YELLOW, (x2+1, y, self.diametre, self.diametre), math.radians(0-self.angle) ,math.radians(90-self.angle), self.thickness)

        pygame.draw.arc(self.surface, VIOLET , (x2+1, y, self.diametre, self.diametre), math.radians(90-self.angle) , math.radians(180-self.angle), self.thickness)

        pygame.draw.arc(self.surface, PINK  , (x2+1, y, self.diametre, self.diametre), math.radians(180-self.angle) ,math.radians(270-self.angle), self.thickness)

        pygame.draw.arc(self.surface, TURQUOISE , (x2+1, y, self.diametre, self.diametre), math.radians(270-self.angle) ,math.radians(360-self.angle), self.thickness)



class Obstacle3:

    def __init__(self, surface, x, y, vitesse = 1, diametre = 320, thickness = 50, angle = 0, angle2 = 0):

        self.y = y

        self.x= x

        self.angle = angle

        self.angle2= angle2
        
        self.surface = surface

        self.diametre = diametre

        self.vitesse = vitesse
        
        self.thickness = thickness

    def update(self):


        y = self.y-float(self.diametre/2)-pov.y

        if(y >= H):

            obstacles3.remove(self)

            return

        self.angle+=self.vitesse
        
        self.angle2-=self.vitesse

        if(self.angle > 360):

            self.angle-=360

    def draw(self):

        
        y = self.y-float(self.diametre/2)-pov.y
        x = self.x-float(self.diametre/2)

        pygame.draw.arc(self.surface, VIOLET , (x, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, YELLOW , (x, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, TURQUOISE , (x, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(self.diametre+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, PINK , (x, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), int(self.thickness/2))

       

        pygame.draw.arc(self.surface, VIOLET , (x+1, y, self.diametre, self.diametre), math.radians(0+self.angle) ,math.radians(90+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, YELLOW , (x+1, y, self.diametre, self.diametre), math.radians(90+self.angle) , math.radians(180+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, TURQUOISE , (x+1, y, self.diametre, self.diametre), math.radians(180+self.angle) ,math.radians(270+self.angle), int(self.thickness/2))

        pygame.draw.arc(self.surface, PINK , (x+1, y, self.diametre, self.diametre), math.radians(270+self.angle) ,math.radians(360+self.angle), int(self.thickness/2))

        
        y2 = self.y-float(self.diametre/2)+self.thickness/2-pov.y
        x2 = self.x-float(self.diametre/2)+self.thickness/2
            
        pygame.draw.arc(self.surface, YELLOW , (x2, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(0+self.angle2) ,math.radians(90+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, VIOLET , (x2, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(90+self.angle2) , math.radians(180+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, PINK , (x2, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(180+self.angle2) ,math.radians(self.diametre+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, TURQUOISE , (x2, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(270+self.angle2) ,math.radians(360+self.angle2), int(self.thickness/2))

       

        pygame.draw.arc(self.surface, YELLOW , (x2+1, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(0+self.angle2) ,math.radians(90+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, VIOLET , (x2+1, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(90+self.angle2) , math.radians(180+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, PINK , (x2+1, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(180+self.angle2) ,math.radians(270+self.angle2), int(self.thickness/2))

        pygame.draw.arc(self.surface, TURQUOISE , (x2+1, y2, self.diametre-self.thickness, self.diametre-self.thickness), math.radians(270+self.angle2) ,math.radians(360+self.angle2), int(self.thickness/2))
 

class Etoile:

    def __init__(self, surface, x, y):

        self.x = x

        self.y = y

        self.surface = surface

        self.color = WHITE

    def draw(self):

        x, y = self.x, self.y-pov.y

        pygame.gfxdraw.filled_polygon(self.surface, ((x,y-16),(x-7,y-5), (x-20,y-3), (x-11,y+8), (x-13, y+21), (x, y+16), (x+13, y+21), (x+11, y+8), (x+20, y-3), (x+7,y-5)), self.color)

        pygame.gfxdraw.aapolygon(self.surface, ((x,y-16),(x-7,y-5), (x-20,y-3), (x-11,y+8), (x-13, y+21), (x, y+16), (x+13, y+21), (x+11, y+8), (x+20, y-3), (x+7,y-5)), self.color)

      

class Boule_de_changement_de_couleur:

    def __init__(self, surface, x, y, color = random_color()):

        self.x = x

        self.y = y

        self.surface = surface

        self.rayon = 22

        self.color = color

    def draw(self):

        x, y = self.x , int(self.y-2*self.rayon-pov.y)

        pygame.draw.arc(self.surface, VIOLET , (228, y, 44, 44), math.radians(0) ,math.radians(90), self.rayon)

        pygame.draw.arc(self.surface, YELLOW , (228, y, 44, 44), math.radians(90) , math.radians(180), self.rayon)

        pygame.draw.arc(self.surface, TURQUOISE , (228, y, 44, 44), math.radians(180) ,math.radians(270), self.rayon)

        pygame.draw.arc(self.surface, PINK , (228, y, 44, 44), math.radians(270) ,math.radians(360), self.rayon)

       

        pygame.draw.arc(self.surface, VIOLET , (228+1, y, 44, 44), math.radians(0) ,math.radians(90), self.rayon)

        pygame.draw.arc(self.surface, YELLOW , (228+1, y, 44, 44), math.radians(90) , math.radians(180), self.rayon)

        pygame.draw.arc(self.surface, TURQUOISE , (228+1, y, 44, 44), math.radians(180) ,math.radians(270), self.rayon)

        pygame.draw.arc(self.surface, PINK , (228+1, y, 44, 44), math.radians(270) ,math.radians(360), self.rayon)

       

        pygame.draw.arc(self.surface, VIOLET , (228+2, y, 44, 44), math.radians(0) ,math.radians(90), self.rayon)

        pygame.draw.arc(self.surface, YELLOW , (228+2, y, 44, 44), math.radians(90) , math.radians(180), self.rayon)

        pygame.draw.arc(self.surface, TURQUOISE , (228+2, y, 44, 44), math.radians(180) ,math.radians(270), self.rayon)

        pygame.draw.arc(self.surface, PINK , (228+2, y, 44, 44), math.radians(270) ,math.radians(360), self.rayon)

       

 

 

 

 

class Ball:

    def __init__(self, surface, x, y):

        self.x = x

        self.y = y

        self.rayon = 10

        self.surface = surface

        self.vel = 0

        self.color = random_color()

        self.dead = False

    def collision_detection(self):

        global score, highscore

        x, y = self.x, self.y-pov.y

        for etoile in etoiles:

            if(etoile.y+16 > self.y-self.rayon):

                etoiles.remove(etoile)

                score+=1   

        for obs in obstacles:

            if(obs.y+int(270/2) >= self.y-self.rayon and obs.y+int(270/2)-30 <= self.y+self.rayon):

                if(self.color != TURQUOISE and obs.angle + 10/1.5 <= 90):

                    self.dead = True

                elif(self.color != YELLOW and obs.angle - 10/1.5 > 90 and obs.angle + 10/1.5 <= 180):

                    self.dead = True

                elif(self.color != VIOLET and obs.angle - 10/1.5 > 180 and obs.angle + 10/1.5 <= 270):

                    self.dead = True

                elif(self.color != PINK and obs.angle - 10/1.5 > 270 and obs.angle + 10/1.5 <= 360):

                    self.dead = True

            elif(obs.y-(270/2)+30 >= self.y-self.rayon and obs.y-(270/2) <= self.y):

                if(self.color != VIOLET and obs.angle - 10/1.5 <= 90):

                    self.dead = True

                elif(self.color != PINK and obs.angle - 10/1.5 > 90 and obs.angle + 10/1.5 <= 180):

                    self.dead = True

                elif(self.color != TURQUOISE and obs.angle - 10/1.5 > 180 and obs.angle + 10/1.5 <= 270):

                    self.dead = True

                elif(self.color != YELLOW and obs.angle - 10/1.5 > 270 and obs.angle + 10/1.5 <= 360):

                    self.dead = True

            elif(self.y>=H):

                self.dead = True

        for obs2 in obstacles2: 
            
            if( (self.y-obs2.y)**2 + 125**2 < (10 + 125)**2):

                if(self.color != PINK and obs2.angle + 10/1.5 <= 90):

                    self.dead = True

                elif(self.color != TURQUOISE and obs2.angle - 10/1.5 > 90 and obs2.angle + 10/1.5 <= 180):

                    self.dead = True

                elif(self.color != YELLOW and obs2.angle - 10/1.5 > 180 and obs2.angle + 10/1.5 <= 270):

                    self.dead = True

                elif(self.color != VIOLET and obs2.angle - 10/1.5 > 270 and obs2.angle + 10/1.5 <= 360):

                    self.dead = True
            

            elif(self.y>=H):

                self.dead = True
                
        
        for obs3 in obstacles3:
                        
            if(obs3.y+int(320/2) >= self.y-self.rayon and obs3.y+int(320/2)-50 <= self.y+self.rayon):

                if(self.color != TURQUOISE and obs3.angle + 10/1.5 <= 90):

                    self.dead = True

                elif(self.color != YELLOW and obs3.angle - 10/1.5 > 90 and obs3.angle + 10/1.5 <= 180):

                    self.dead = True

                elif(self.color != VIOLET and obs3.angle - 10/1.5 > 180 and obs3.angle + 10/1.5 <= 270):

                    self.dead = True

                elif(self.color != PINK and obs3.angle - 10/1.5 > 270 and obs3.angle + 10/1.5 <= 360):

                    self.dead = True

            elif(obs3.y-(320/2)+50 >= self.y-self.rayon and obs3.y-(320/2) <= self.y):

                if(self.color != VIOLET and obs3.angle - 10/1.5 <= 90):

                    self.dead = True

                elif(self.color != PINK and obs3.angle - 10/1.5 > 90 and obs3.angle + 10/1.5 <= 180):

                    self.dead = True

                elif(self.color != TURQUOISE and obs3.angle - 10/1.5 > 180 and obs3.angle + 10/1.5 <= 270):

                    self.dead = True

                elif(self.color != YELLOW and obs3.angle - 10/1.5 > 270 and obs3.angle + 10/1.5 <= 360):

                    self.dead = True

            elif(self.y>=H):

                self.dead = True
            

        for cc in ccs:

            if(cc.y+cc.rayon > self.y-self.rayon):

                self.color = cc.color

                ccs.remove(cc)  

    def update(self):

        if(not self.dead):

            self.vel -= 0.5

            self.y -= self.vel

            if(pov.y >= self.y-350):

                pov.y = self.y-350

            self.collision_detection()

        elif(self.dead):
            global gamestate
            gamestate = GAMEOVER
               

    def draw(self):

        x, y = self.x, int(self.y-pov.y)

       

        if(not self.dead):

            pygame.gfxdraw.filled_circle(self.surface, x, y, self.rayon, self.color)

            pygame.gfxdraw.aacircle(self.surface, x, y, self.rayon, self.color)

        else:

            global gamestate

            gamestate = GAMEOVER

 

def start():

    global pov, ball, obstacles, score, Obstacle , obstacles2, Obstacle2, obstacles3, Obstacle3

    pov = Pov()

    ball = Ball(screen, 250, 400)

    del etoiles[:]

    del obstacles[:]

    del ccs[:]

    del obstacles2[:]
    
    del obstacles3[:]

    score = 0

    for i in range(1000):
        a=0
        a= rdm.randint(1 , 3)
        if a == 1:

            obs_prov = Obstacle(screen, 250, -500*i, 1+i/10)
            obstacles.append(obs_prov)
        
        elif a == 2:
             obs_prov = Obstacle2(screen, 250, -500*i, 1+i/10)
             obstacles2.append(obs_prov)
             
        elif a == 3:
             obs_prov = Obstacle3(screen, 250, -500*i, 1+i/10)
             obstacles3.append(obs_prov)
        
        cc_prov = Boule_de_changement_de_couleur(screen, 250, -500*i+250,random_color())

        ccs.append(cc_prov)

        etoile_prov = Etoile(screen, 250, -500*i)

        etoiles.append(etoile_prov)

 

def handle_events():

    global gamestate

    for event in pygame.event.get():

        if(event.type == pygame.QUIT):

            return False

        if(event.type == pygame.KEYDOWN):

            if(event.key == pygame.K_ESCAPE):

                return False

            elif(event.key == pygame.K_SPACE):

                if(gamestate == GAMEPLAY):

                    ball.vel = 8

                elif(gamestate == GAMEOVER):

                    gamestate = GAMEPLAY

                    start()

                elif(gamestate == MENU):

                    gamestate = GAMEPLAY

                    start()

    return True

 

def draw_ui():

    screen.blit(ecriture.render(str(score), True, WHITE), (10, 10))

menu_obstacle = Obstacle(screen, 175, 100, 1, 80, 10)
menu_obstacle2 = Obstacle(screen, 305, 100, 1, 80, 10)

menu_obstacle3 = Obstacle(screen, 250, 400, 1, 210, 20, 148)
menu_obstacle4 = Obstacle(screen, 250, 400, -1, 280, 25, 268 )
menu_obstacle5 = Obstacle(screen, 250, 400, 1, 360, 30, 28)



def draw_menu():

    screen.blit(grosse_ecriture.render("C    L    R", True, WHITE), (70, 60))

    menu_obstacle.draw()
    menu_obstacle.update()
    
    menu_obstacle2.draw()
    menu_obstacle2.update()
    
    menu_obstacle3.draw()
    menu_obstacle3.update()
    
    menu_obstacle4.draw()
    menu_obstacle4.update()
    
    menu_obstacle5.draw()
    menu_obstacle5.update()
    
    pygame.gfxdraw.filled_polygon(screen, ((200,350),(200,450), (300,400)), WHITE)


 
    screen.blit(grosse_ecriture.render("SWITCH", True, WHITE), (80, 150))

    screen.blit(ecriture.render("press space to begin", True, WHITE), (100, 630))

 

def draw_game_over():
    
    global score, highscore

    if(score > highscore):
                highscore = score        
    screen.blit(grosse_ecriture.render("SCORE", True, WHITE), (110, 80))
    screen.blit(grosse_ecriture.render(str(score), True, WHITE), (230, 160))

    screen.blit(grosse_ecriture.render("HIGHSCORE", True, WHITE), (0, 390))
    screen.blit(grosse_ecriture.render(str(highscore), True, WHITE), (230, 470))
    
    screen.blit(ecriture.render("press space to retry", True, WHITE), (100, 630))

 

 

while(handle_events()):

    clock.tick(70)

    screen.fill(BLACK)

    if(gamestate == MENU):

        draw_menu()

    elif(gamestate == GAMEPLAY):

        ball.update()

        ball.draw()

        for obs in obstacles:

            if(obs.y+270/2 >= pov.y):

                obs.draw()

                obs.update()

        for obs2 in obstacles2:

            if(obs2.y+obs2.diametre/2 >= pov.y):

                obs2.draw()

                obs2.update()
                
        for obs3 in obstacles3:

            if(obs3.y+obs3.diametre/2 >= pov.y):

                obs3.draw()

                obs3.update()

        for etoile in etoiles:

            if(etoile.y >= pov.y):

                etoile.draw()

        for cc in ccs:

            if(cc.y>= pov.y):

                cc.draw()     

        draw_ui()

    elif(gamestate == GAMEOVER):

        draw_game_over()

    pygame.display.update()

pygame.quit()

